Imports System.Reflection

Public Class CodePart

    Public Enum CodePartType
        icNamespacePart = 0
        icTypePart = 1
        icPropertyPart = 2
        icMethodPart = 3
        icEventPart = 4
        icFieldPart = 5
    End Enum

    Private m_iPartType As CodePartType
    Private m_sNamespaceName As String
    Private m_oType As Type
    Private m_oMethod As MethodInfo
    Private m_oProperty As PropertyInfo
    Private m_oEvent As EventInfo
    Private m_oField As FieldInfo

    Public ReadOnly Property PartType() As CodePartType
        Get
            Return m_iPartType
        End Get
    End Property

    Public Sub New(ByVal psNamespaceName As String)
        m_iPartType = CodePartType.icNamespacePart
        m_sNamespaceName = psNamespaceName
    End Sub

    Public Sub New(ByVal poType As Type)
        m_iPartType = CodePartType.icTypePart
        m_oType = poType
    End Sub

    Public Sub New(ByVal poMethod As MethodInfo)
        m_iPartType = CodePartType.icMethodPart
        m_oMethod = poMethod
    End Sub

    Public Sub New(ByVal poProperty As PropertyInfo)
        m_iPartType = CodePartType.icPropertyPart
        m_oProperty = poProperty
    End Sub

    Public Sub New(ByVal poEvent As EventInfo)
        m_iPartType = CodePartType.icEventPart
        m_oEvent = poEvent
    End Sub

    Public Sub New(ByVal poField As FieldInfo)
        m_iPartType = CodePartType.icFieldPart
        m_oField = poField
    End Sub

End Class