Imports EnvDTE
Imports System.IO
Imports Extensibility
Imports System.Windows.Forms
Imports Microsoft.Office.Core
Imports System.Runtime.InteropServices

''' <summary>
'''   The object for implementing an Add-in.
''' </summary>
''' <seealso class='IDTExtensibility2' />



' Use different GUID and ProgID for 2002 and 2003, so that you could
' have both versions installed at the same time, if you had VS2002 and
' VS2003 installed.
#If VBNET2002 Then
<Guid("7A240A47-155A-4c50-A519-80EF2A18C21F"), ProgId("Commentator2002.Connect")> _
Public Class Connect
#Else
<Guid("8A61D675-20BE-4ED2-AFFC-0017B370FDF5"), ProgId("Commentator.Connect")> _
Public Class Connect
#End If

    Implements IDTExtensibility2
    Implements IDTCommandTarget

#Region " Member Variables "

	Private ApplicationObject As EnvDTE.DTE
    Private CommenterInstance As VBCommenter
    Private CommentWriter As XmlWriter

    Private Const CommandName As String = "VBCommenter"

    'TODO: fix this in the future to build on a per project, per project build type basis -mybutt
    Private BuildXMLFiles As Boolean = True
    Private DocumentationFiles As ArrayList

    Private TextEditorEvents As TextEditorEvents
    Private BuildEvents As BuildEvents
	Private SolutionEvents As SolutionEvents
    Private TaskListEvents As TaskListEvents
    Private AddInInstance As EnvDTE.AddIn

    Private ReadOnly Property IsCommandlineBuild() As Boolean
        Get
            If ApplicationObject.CommandLineArguments.ToLower.LastIndexOf("/build") <> -1 Then
                Return True
            ElseIf ApplicationObject.CommandLineArguments.ToLower.LastIndexOf("/rebuild") <> -1 Then
                Return True
            Else
                Return False
            End If


        End Get
    End Property

#End Region

#Region " Constructor "

    ''' <summary>
    '''		Implements the constructor for the Add-in object.
    '''		Place your initialization code within this method.
    ''' </summary>
    Public Sub New()
    End Sub

#End Region

#Region " OnConnection Method "

    ''' <summary>
    '''      Implements the OnConnection method of the IDTExtensibility2 interface.
    '''      Receives notification that the Add-in is being loaded.
    ''' </summary>
    ''' <param term='application'>
    '''      Root object of the host application.
    ''' </param>
    ''' <param term='connectMode'>
    '''      Describes how the Add-in is being loaded.
    ''' </param>
    ''' <param term='addInInst'>
    '''      Object representing this Add-in.
    ''' </param>
    ''' <remarks>Uncomment the buildEvents lines to turn the XML 
    ''' IntelliSense file generation on.</remarks>
    ''' <seealso class='IDTExtensibility2' />
    Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As Array) Implements IDTExtensibility2.OnConnection
        AddInInstance = DirectCast(addInInst, EnvDTE.AddIn)

        ' Removed 2/25/2005 - DTR2 - As we only load assemblies via a read-only file stream to an array of bytes, we should not need to do this
        ' It does help sometimes while developing VBCommenter itself, as it makes the IDE shatow copy the VBCommenter dll.
        ' AppDomain.CurrentDomain.SetShadowCopyFiles()

		ApplicationObject = DirectCast(application, EnvDTE.DTE)

        'Grab new instances of the Commenter and Writer
        CommenterInstance = New VBCommenter()
        CommentWriter = New XmlWriter(ApplicationObject)

        'Setup Text Editor Event Handlers
        TextEditorEvents = ApplicationObject.Events.TextEditorEvents(Nothing)
        AddHandler TextEditorEvents.LineChanged, AddressOf TextEditorEvents_LineChanged

        'Setup Build Event Handlers
        BuildEvents = DirectCast(ApplicationObject.Events.BuildEvents, EnvDTE.BuildEvents)
        AddHandler BuildEvents.OnBuildProjConfigDone, AddressOf BuildEvents_OnBuildProjConfigDone
        'AddHandler BuildEvents.OnBuildDone, AddressOf BuildEvents_OnBuildDone

        'Setup Solution Event Handlers
        SolutionEvents = DirectCast(ApplicationObject.Events.SolutionEvents, EnvDTE.SolutionEvents)
        AddHandler SolutionEvents.BeforeClosing, AddressOf SolutionEvents_BeforeClosing
        AddHandler SolutionEvents.AfterClosing, AddressOf SolutionEvents_AfterClosing

		' Tasklist event handler
		TaskListEvents = DirectCast(ApplicationObject.Events.TaskListEvents, EnvDTE.TaskListEvents)
		AddHandler TaskListEvents.TaskNavigated, AddressOf TaskListEvents_TaskNavigated

        'If we're starting up, make sure the menu command is setup properly
        'If connectMode = Extensibility.ext_ConnectMode.ext_cm_UISetupThen
        Dim contextGUIDS() As Object
        Dim commands As Commands = ApplicationObject.Commands

        'If connectMode = ext_ConnectMode.ext_cm_UISetup Or connectMode = ext_ConnectMode.ext_cm_AfterStartup Then
        If Not VBCommenterCommandExists() Then
            Dim ToolsCommandBar As CommandBar = DirectCast(ApplicationObject.CommandBars.Item("Tools"), CommandBar)
            Dim VBCommenterCommand As Command = commands.AddNamedCommand(AddInInstance, CommandName, "VBCommenter Options", "Options for VBCommenter", True, 343, contextGUIDS, CType(vsCommandStatus.vsCommandStatusSupported, Integer) + CType(vsCommandStatus.vsCommandStatusEnabled, Integer))

            VBCommenterCommand.AddControl(ToolsCommandBar, 1)
        End If
        'End If
    End Sub

#End Region

#Region " Event Methods "

    ''' <summary>
    '''     Implements the OnDisconnection method of the IDTExtensibility2 interface.
    '''     Receives notification that the Add-in is being unloaded.
    ''' </summary>
    ''' <param term='disconnectMode'>
    '''      Describes how the Add-in is being unloaded.
    ''' </param>
    ''' <param term='custom'>
    '''      Array of parameters that are host application specific.
    ''' </param>
    ''' <seealso class='IDTExtensibility2' />
    Public Sub OnDisconnection(ByVal disconnectMode As Extensibility.ext_DisconnectMode, ByRef custom As Array) Implements IDTExtensibility2.OnDisconnection

        ' remove command from tools menu
        If disconnectMode = ext_DisconnectMode.ext_dm_UserClosed Then
            If VBCommenterCommandExists() Then
                Dim SearchString As String = GetProgId() & "." & CommandName
                ApplicationObject.Commands.Item(SearchString).Delete()
            End If
        End If

        RemoveHandler TextEditorEvents.LineChanged, AddressOf TextEditorEvents_LineChanged

        'Setup Build Event Handlers
        BuildEvents = DirectCast(ApplicationObject.Events.BuildEvents, EnvDTE.BuildEvents)
        RemoveHandler BuildEvents.OnBuildProjConfigDone, AddressOf BuildEvents_OnBuildProjConfigDone
        'RemoveHandler BuildEvents.OnBuildDone, AddressOf BuildEvents_OnBuildDone

        'Setup Solution Event Handlers
        SolutionEvents = DirectCast(ApplicationObject.Events.SolutionEvents, EnvDTE.SolutionEvents)
        RemoveHandler SolutionEvents.BeforeClosing, AddressOf SolutionEvents_BeforeClosing
        RemoveHandler SolutionEvents.AfterClosing, AddressOf SolutionEvents_AfterClosing

        ' Tasklist event handler
        TaskListEvents = DirectCast(ApplicationObject.Events.TaskListEvents, EnvDTE.TaskListEvents)
        RemoveHandler TaskListEvents.TaskNavigated, AddressOf TaskListEvents_TaskNavigated

        'If we're starting up, make sure the menu command is setup properly
        'If connectMode = Extensibility.ext_ConnectMode.ext_cm_UISetupThen
        Dim contextGUIDS() As Object
        Dim commands As Commands = ApplicationObject.Commands

        'If connectMode = ext_ConnectMode.ext_cm_UISetup Or connectMode = ext_ConnectMode.ext_cm_AfterStartup Then
        If Not VBCommenterCommandExists() Then
            Dim ToolsCommandBar As CommandBar = DirectCast(ApplicationObject.CommandBars.Item("Tools"), CommandBar)
            Dim VBCommenterCommand As Command = commands.AddNamedCommand(AddInInstance, CommandName, "VBCommenter Options", "Options for VBCommenter", True, 343, contextGUIDS, CType(vsCommandStatus.vsCommandStatusSupported, Integer) + CType(vsCommandStatus.vsCommandStatusEnabled, Integer))

            VBCommenterCommand.AddControl(ToolsCommandBar, 1)
        End If
        'End If
    End Sub

    ''' <summary>
    '''      Implements the OnAddInsUpdate method of the IDTExtensibility2 interface.
    '''      Receives notification that the collection of Add-ins has changed.
    ''' </summary>
    ''' <param term='custom'>
    '''      Array of parameters that are host application specific.
    ''' </param>
    ''' <seealso class='IDTExtensibility2' />
    Public Sub OnAddInsUpdate(ByRef custom As Array) Implements IDTExtensibility2.OnAddInsUpdate
    End Sub

    ''' <summary>
    '''      Implements the OnStartupComplete method of the IDTExtensibility2 interface.
    '''      Receives notification that the host application has completed loading.
    ''' </summary>
    ''' <param term='custom'>
    '''      Array of parameters that are host application specific.
    ''' </param>
    ''' <seealso class='IDTExtensibility2' />
    Public Sub OnStartupComplete(ByRef custom As Array) Implements IDTExtensibility2.OnStartupComplete
    End Sub

    ''' <summary>
    '''      Implements the OnBeginShutdown method of the IDTExtensibility2 interface.
    '''      Receives notification that the host application is being unloaded.
    ''' </summary>
    ''' <param term='custom'>
    '''      Array of parameters that are host application specific.
    ''' </param>
    ''' <seealso class='IDTExtensibility2' />
    Public Sub OnBeginShutdown(ByRef custom As Array) Implements IDTExtensibility2.OnBeginShutdown
    End Sub

    ''' <summary>
    ''' Event occurs when a line is changed in the project being operated on.
    ''' This is how we know when to try to add an xml-comment header to a class, method, or property
    ''' </summary>
	''' <param name="StartPoint">A TextPoint object representing the beginning of the line that was changed.</param>
	''' <param name="EndPoint">A TextPoint object representing the end of the line that was changed. </param>
	''' <param name="Hint">A vsTextChanged constant indicating one or more reasons why the event occurred, which may help you understand what happened in the buffer. </param>
    Protected Sub TextEditorEvents_LineChanged(ByVal StartPoint As EnvDTE.TextPoint, ByVal EndPoint As EnvDTE.TextPoint, ByVal Hint As Integer)

        If IsNormalTextInsertion(Hint, StartPoint) Then
            ' Would it be better to add/remove this handler instead of checking always?
            Dim oConfig As Configuration = Configuration.GetInstance()

            If oConfig.InsertXMLComments Then
                CommenterInstance.Commentate(StartPoint, EndPoint, Hint)
            End If
        End If
    End Sub

    Private Function IsNormalTextInsertion(ByVal piHint As Integer, ByVal poStartPoint As EnvDTE.TextPoint) As Boolean

        Dim bNormal As Boolean = False

        If (piHint And 1) = 1 Then
            ' Most likely caused by a paste operation
            bNormal = False
        ElseIf (piHint And 8) = 8 Then
            ' Most likely caused by a drag & drop operation
            bNormal = False
        Else
            bNormal = True
        End If

        If bNormal Then
            If Not poStartPoint.Parent Is Nothing Then
                If Not poStartPoint.Parent.Parent Is Nothing Then
                    If Not poStartPoint.Parent.Parent.ActiveWindow Is Nothing Then
                        If Not poStartPoint.Parent.Parent.ActiveWindow.Selection Is Nothing Then
                            bNormal = True
                        Else
                            bNormal = False
                        End If
                    Else
                        bNormal = False
                    End If
                End If
            End If
        End If


        Return bNormal

    End Function

    ''' <summary>
    ''' Event fired when the project finishes building, kicks off the xml-file production process
    ''' </summary>
    Public Sub BuildEvents_OnBuildProjConfigDone(ByVal Project As String, ByVal ProjectConfig As String, ByVal Platform As String, ByVal SolutionConfig As String, ByVal Success As Boolean)

        ' Would it be better to add/remove this handler instead of checking always?
        Dim oConfig As Configuration = Configuration.GetInstance()

        If Success AndAlso oConfig.CreateXMLFiles Then
            CommentWriter.Write(Project, ProjectConfig, Platform)
        End If
    End Sub

    ''' <summary>
    ''' Called before the project is closed.  Grab a list of Xml files we wrote.
    ''' don't do this anymore.   We now create the xml file as C# does.  06/13/03 - cbreisch
    ''' </summary>
    Public Sub SolutionEvents_BeforeClosing()
        'Try
        '	DocumentationFiles = New ArrayList
        '	For Each project As Project In DirectCast(ApplicationObject.GetObject("VBProjects"), Projects)
        '		DocumentationFiles.Add(DirectCast(project.Properties.Item("fullpath").Value, String) & DirectCast(project.ConfigurationManager.Item(project.ConfigurationManager.ActiveConfiguration.ConfigurationName, project.ConfigurationManager.ActiveConfiguration.PlatformName).Properties.Item("intermediatepath").Value, String) & DirectCast(project.Properties.Item("assemblyname").Value, String) & ".xml_")
        '	Next
        'Catch Ex As Exception
        '	MessageBox.Show("VBCommenter Add-in: Error accessing Xml files " & Environment.NewLine & Ex.Message & Environment.NewLine & Ex.StackTrace, "VBCommenter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        'End Try
    End Sub

    ''' <summary>
    ''' Called after the project closes.  Change extention of xml files from ".xml_" to ".xml"
    ''' don't do this anymore.  We now create the xml file as C# does. 06/13/03 - cbreisch
    ''' </summary>
    Public Sub SolutionEvents_AfterClosing()
        'Try
        '	For Each FileName As String In DocumentationFiles
        '		If File.Exists(FileName) Then
        '			If File.Exists(FileName.TrimEnd("_".ToCharArray)) Then
        '				File.Delete(FileName.TrimEnd("_".ToCharArray))
        '			End If

        '			File.Move(FileName, FileName.TrimEnd("_".ToCharArray))
        '		End If
        '	Next
        'Catch Ex As Exception
        '	MessageBox.Show("VBCommenter Add-in: Failure converting file extensions on Xml files " & Ex.Message & Environment.NewLine & Ex.StackTrace, "VBCommenter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        'End Try
    End Sub

    ''' <summary>
    ''' Handles when an item is clicked on the task list
    ''' </summary>
    ''' <remarks> Based on C# example in "Inside Microsoft Visual Studio.NET", p.311</remarks>
    Public Sub TaskListEvents_TaskNavigated(ByVal taskItem As EnvDTE.TaskItem, ByRef navigateHandled As Boolean)

        If (taskItem.FileName <> "") Then
            Dim fileWindow As EnvDTE.Window
            Dim textWindow As EnvDTE.TextWindow
            Dim textPane As EnvDTE.TextPane

            ' open the file, find the textwindow and textpane objects
            fileWindow = ApplicationObject.ItemOperations.OpenFile(taskItem.FileName, EnvDTE.Constants.vsViewKindTextView)
            textWindow = DirectCast(fileWindow.Object, EnvDTE.TextWindow)
            textPane = DirectCast(textWindow.ActivePane, EnvDTE.TextPane)

            ' move the caret to the correct line
            textPane.Selection.MoveToLineAndOffset(taskItem.Line, 1, False)
            textPane.Selection.SelectLine()
            navigateHandled = True
        End If
    End Sub
#End Region

#Region " QueryStatus Method "

    ''' <summary>
    '''      Implements the QueryStatus method of the IDTCommandTarget interface.
    '''      This is called when the command's availability is updated
    ''' </summary>
    ''' <param term='commandName'>
    '''		The name of the command to determine state for.
    ''' </param>
    ''' <param term='neededText'>
    '''		Text that is needed for the command.
    ''' </param>
    ''' <param term='status'>
    '''		The state of the command in the user interface.
    ''' </param>
    ''' <param term='commandText'>
    '''		Text requested by the neededText parameter.
    ''' </param>
    ''' <seealso class='Exec' />
    Public Sub QueryStatus(ByVal commandName As String, ByVal neededText As EnvDTE.vsCommandStatusTextWanted, ByRef status As EnvDTE.vsCommandStatus, ByRef commandText As Object) Implements IDTCommandTarget.QueryStatus
        If neededText = EnvDTE.vsCommandStatusTextWanted.vsCommandStatusTextWantedNone Then
            If commandName = GetProgId() & "." & Me.CommandName Then
                status = vsCommandStatus.vsCommandStatusSupported Or vsCommandStatus.vsCommandStatusEnabled
            End If
        End If
    End Sub

#End Region

#Region " Exec Method "

    ''' <summary>
    '''      Implements the Exec method of the IDTCommandTarget interface.
    '''      This is called when the command is invoked.
    ''' </summary>
    ''' <param term='commandName'>
    '''		The name of the command to execute.
    ''' </param>
    ''' <param term='executeOption'>
    '''		Describes how the command should be run.
    ''' </param>
    ''' <param term='varIn'>
    '''		Parameters passed from the caller to the command handler.
    ''' </param>
    ''' <param term='varOut'>
    '''		Parameters passed from the command handler to the caller.
    ''' </param>
    ''' <param term='handled'>
    '''		Informs the caller if the command was handled or not.
    ''' </param>
    ''' <seealso class='Exec' />
    Public Sub Exec(ByVal commandName As String, ByVal executeOption As EnvDTE.vsCommandExecOption, ByRef varIn As Object, ByRef varOut As Object, ByRef handled As Boolean) Implements IDTCommandTarget.Exec
        handled = False
        If executeOption = EnvDTE.vsCommandExecOption.vsCommandExecOptionDoDefault Then

            If commandName = GetProgId() & "." & Me.CommandName Then
                If Not IsCommandlineBuild() Then
                    Dim settings As New frmSettings
                    settings.ShowDialog()

                    'Dim result As DialogResult = MessageBox.Show("Would you like an XML comment file generated when your projects build?", "Build XML Comment File?", MessageBoxButtons.YesNoCancel)
                    'If result = DialogResult.Yes Then
                    '    BuildXMLFiles = True
                    'ElseIf result = DialogResult.No Then
                    '    BuildXMLFiles = False
                    'End If

                    handled = True
                    Exit Sub
                End If
            Else
                Console.WriteLine("ERROR: The command " + commandName + " is not compatible with commandline mode operation")
                handled = True
                Exit Sub
            End If
        End If
    End Sub

#End Region

#Region " VBCommenterCommandExists Method "

    Private Function VBCommenterCommandExists() As Boolean
        Dim SearchString As String = GetProgId() & "." & CommandName

        Dim Command As Command
        For Each Command In ApplicationObject.Commands
            If Command.Name = SearchString Then
                Return True
            End If
        Next

        Return False
    End Function

#End Region

#Region " GetProgId Method "

    Private Function GetProgId() As String
        Dim Attributes() As Object = Me.GetType.GetCustomAttributes(False)

        Dim i As Integer
        For i = 0 To Attributes.GetUpperBound(0)
            If TypeOf Attributes(i) Is ProgIdAttribute Then
                Return DirectCast(Attributes(i), ProgIdAttribute).Value
            End If
        Next

        Return ""
    End Function

#End Region

End Class