Imports System.Reflection

Public Class NamespaceCollection
    Implements IEnumerable

    Private moAssemblyDirectory As New Hashtable
    Private moNamespaceDirectory As New Hashtable

    Public Sub Add(ByVal psNamespace As String, ByVal poAssembly As [Assembly])

        Dim sAssemblyName As String
        Dim oAssemblies As ArrayList
        sAssemblyName = poAssembly.GetName.Name

        moAssemblyDirectory.Add(sAssemblyName + "!" + psNamespace, poAssembly)
        If Exists(psNamespace) Then
            oAssemblies = DirectCast(moNamespaceDirectory.Item(psNamespace), ArrayList)
        Else
            oAssemblies = New ArrayList
            moNamespaceDirectory.Add(psNamespace, oAssemblies)
        End If

        oAssemblies.Add(poAssembly)

    End Sub

    Public Function Exists(ByVal psNamespace As String) As Boolean
        Return moNamespaceDirectory.ContainsKey(psNamespace)
    End Function

    Public Function Exists(ByVal psNamespace As String, ByVal poAssembly As [Assembly]) As Boolean
        Dim sAssemblyName As String
        sAssemblyName = poAssembly.GetName.Name
        Return moAssemblyDirectory.ContainsKey(sAssemblyName + "!" + psNamespace)
    End Function


    Private _matchHash As Hashtable = New Hashtable

    Public Sub CacheMatch(ByVal namespaceName As String, ByVal crefClassName As String, ByVal type As System.Type)
        _matchHash(namespaceName + "." + crefClassName) = type
    End Sub

    Public Function GetCachedType(ByVal namespaceName As String, ByVal crefClassName As String) As System.Type
        Dim completeName As String = namespaceName + "." + crefClassName
        If _matchHash.ContainsKey(completeName) Then
            Return DirectCast(_matchHash(completeName), System.Type)
        Else
            Return Nothing
        End If
    End Function


    Public Function GetAssembliesForNamespace(ByVal psNamespace As String) As [Assembly]()

        Dim oAssemblies As ArrayList
        Dim aRet As [Assembly]()
        Dim iPos As Integer
        If Exists(psNamespace) Then
            oAssemblies = DirectCast(moNamespaceDirectory(psNamespace), ArrayList)
            ReDim aRet(oAssemblies.Count - 1)
            oAssemblies.CopyTo(aRet)
        Else
            aRet = Nothing
        End If

        Return aRet

    End Function

    Public Function GetNamespaceEnumerator() As NamespaceEnumerator
        Return New NamespaceEnumerator(moNamespaceDirectory)
    End Function

    Public Function GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return moAssemblyDirectory.GetEnumerator()
    End Function
End Class
