Imports EnvDTE

Public Enum TemplateTypesEnum
    icDocStubTemplate = 1
    icNotCommentedTemplate = 2
End Enum

Friend Class Template


    Public Shared Function ItemTypes() As String(,)

        Dim aRet(11, 1) As String

        aRet(0, 0) = "Class"
        aRet(0, 1) = "class"
        aRet(1, 0) = "Namespace"
        aRet(1, 1) = "namespace"
        aRet(2, 0) = "Variable"
        aRet(2, 1) = "variable"
        aRet(3, 0) = "Function"
        aRet(3, 1) = "function"
        aRet(4, 0) = "Property"
        aRet(4, 1) = "property"
        aRet(5, 0) = "Delegate"
        aRet(5, 1) = "delegate"
        aRet(6, 0) = "Enum"
        aRet(6, 1) = "enum"
        aRet(7, 0) = "Interface"
        aRet(7, 1) = "interface"
        aRet(8, 0) = "Struct"
        aRet(8, 1) = "struct"
        aRet(9, 0) = "Typedef"
        aRet(9, 1) = "typedef"
        aRet(10, 0) = "Eventsdeclaration"
        aRet(10, 1) = "eventsdeclaration"
        aRet(11, 0) = "Event"
        aRet(11, 1) = "event"

        Return aRet

    End Function

    Public Shared Function IntToTemplateTypeEnum(ByVal piValue As Integer) As TemplateTypesEnum
        Select Case piValue
            Case 1
                Return TemplateTypesEnum.icDocStubTemplate
            Case 2
                Return TemplateTypesEnum.icNotCommentedTemplate
        End Select
    End Function

    Private Shared Function TemplateTypeEnumToString(ByVal piTemplateType As TemplateTypesEnum) As String
        Select Case piTemplateType
            Case TemplateTypesEnum.icDocStubTemplate
                Return "stub"
            Case TemplateTypesEnum.icNotCommentedTemplate
                Return "notdocumented"
        End Select
    End Function

    'Public Shared Sub SetItemTypeTransformation(ByVal piTemplateType As TemplateTypesEnum, ByVal psItemType As String, ByVal pbUseDefault As Boolean, ByVal psValue As String)

    '    Dim oConfig As VBXCAddin.GeneralConfig
    '    Dim oConfigFile As Xml.XmlDocument
    '    Dim oNode As Xml.XmlNode
    '    Dim sTemplateType As String
    '    Dim sNodeLocation As String

    '    oConfig = New VBXCAddin.GeneralConfig

    '    sTemplateType = TemplateTypeEnumToString(piTemplateType)

    '    oConfigFile = oConfig.GetConfigFile()

    '    sNodeLocation = "/config/templates/" + sTemplateType + "/" + psItemType

    '    If pbUseDefault Then
    '        oNode = oConfigFile.SelectSingleNode(sNodeLocation)
    '        If Not oNode Is Nothing Then
    '            oNode.ParentNode.RemoveChild(oNode)
    '        End If
    '    Else
    '        Utils.CreateXPathInXMLDocument(sNodeLocation, oConfigFile)
    '        oNode = oConfigFile.SelectSingleNode(sNodeLocation)
    '        oNode.InnerText = psValue
    '    End If

    '    oConfig.SaveConfigFile(oConfigFile)

    'End Sub

    Public Shared Function GetItemTypeTransformation(ByVal piTemplateType As TemplateTypesEnum, ByVal psItemType As String, ByRef pbInternalResource As Boolean) As String

        Dim bOverridden As Boolean
        Dim sRet As String
        Dim sTemplateType As String
        'Dim oConfig As VBXCAddin.GeneralConfig
        Dim oConfigFile As Xml.XmlDocument
        Dim oNode As Xml.XmlNode
        Dim sNodeLocation As String

        'oConfig = New VBXCAddin.GeneralConfig

        sTemplateType = TemplateTypeEnumToString(piTemplateType)
        oConfigFile = New Xml.XmlDocument   'oConfig.GetConfigFile()
        sNodeLocation = "/config/templates/" + sTemplateType + "/" + psItemType
        oNode = oConfigFile.SelectSingleNode(sNodeLocation)
        bOverridden = False

        If Not oNode Is Nothing Then
            If Not oNode.InnerText = "" Then
                If Not oNode.InnerText.Trim() = "" Then
                    bOverridden = True
                    sRet = oNode.InnerText.Trim()
                End If
            End If
        End If

        If Not bOverridden Then
            pbInternalResource = True
            Select Case piTemplateType
                Case TemplateTypesEnum.icDocStubTemplate
                    sRet = "VBCommenter.default-autoinsert.xslt"
                Case TemplateTypesEnum.icNotCommentedTemplate
                    sRet = "VBCommenter.default-notcommented.xslt"
            End Select

        End If

        Return sRet

    End Function

    Private Shared Function GetDescriptionFromCodeElementsAttributes(ByVal poCodeElement As EnvDTE.CodeElement) As String

        Dim oCodeFunction As EnvDTE.CodeFunction
        Dim oCodeProperty As EnvDTE.CodeProperty
        Dim oCodeVariable As EnvDTE.CodeVariable
        Dim oCodeType As EnvDTE.CodeType
        Dim sRet As String
        Dim oAttributes As EnvDTE.CodeElements
        Dim oCurAttribute As EnvDTE.CodeAttribute
        Dim oCurElement As EnvDTE.CodeElement
        Dim oInfo As Hashtable

        sRet = ""

        If poCodeElement.IsCodeType Then
            oCodeType = CType(poCodeElement, EnvDTE.CodeType)
            oAttributes = oCodeType.Attributes
        ElseIf poCodeElement.Kind = vsCMElement.vsCMElementFunction Then
            oCodeFunction = CType(poCodeElement, EnvDTE.CodeFunction)
            oAttributes = oCodeFunction.Attributes
        ElseIf poCodeElement.Kind = vsCMElement.vsCMElementProperty Then
            oCodeProperty = CType(poCodeElement, EnvDTE.CodeProperty)
            oAttributes = oCodeProperty.Attributes
        ElseIf poCodeElement.Kind = vsCMElement.vsCMElementVariable Then
            oCodeVariable = CType(poCodeElement, EnvDTE.CodeVariable)
            oAttributes = oCodeVariable.Attributes
        End If

        If Not oAttributes Is Nothing Then
            For Each oCurElement In oAttributes
                oCurAttribute = CType(oCurElement, EnvDTE.CodeAttribute)
                'TODO finish this code so that it works (every language implementation probably should have a implementation of 'parse attribute value')
                If Not oCurAttribute Is Nothing AndAlso Not oCurAttribute.FullName Is Nothing Then
                    Select Case oCurAttribute.FullName.ToLower
                        Case "system.componentmodel.descriptionattribute"
                            If Not oCurAttribute.Value Is Nothing Then
                                If oCurAttribute.Value.Length > 0 Then
                                    'HACK we have to manually parse the arguments of the attributes
                                    oInfo = Utils.ParseCodeAttribute(oCurAttribute.Value())
                                    If oInfo.ContainsKey(1) Then
                                        sRet = oInfo.Item(1).ToString.Trim
                                    End If
                                End If
                            End If
                        Case "system.web.services.webmethodattribute", "system.web.services.webserviceattribute"
                            If Not oCurAttribute.Value Is Nothing Then
                                If oCurAttribute.Value.Length > 0 Then
                                    'HACK we have to manually parse the arguments of the attributes
                                    oInfo = Utils.ParseCodeAttribute(oCurAttribute.Value())
                                    If oInfo.ContainsKey("description") Then
                                        sRet = oInfo.Item("description").ToString.Trim
                                    End If
                                End If
                            End If
                    End Select

                    If sRet.Length > 0 Then
                        Exit For
                    End If
                End If

            Next
        End If

        Return sRet

    End Function

    Private Shared Function GetXMLInfoForCodeElement(ByVal poCodeElement As EnvDTE.CodeElement) As String

        Dim sRes As New System.Text.StringBuilder
        Dim sItemType As String
        Dim oFunc As EnvDTE.CodeFunction
        Dim oProp As EnvDTE.CodeProperty
        Dim oPara As EnvDTE.CodeParameter
        Dim oParaList As EnvDTE.CodeParameter()
        Dim bHasReturn As Boolean
        Dim iPos As Integer
        Dim sDescription As String

        sItemType = CodeElement2ItemType(poCodeElement)

        sRes.Append("<xmldocinfo>")
        sRes.Append(System.Environment.NewLine)

        ' Name of project that this item is in
        sRes.Append("<project>")
        sRes.Append(poCodeElement.ProjectItem.ContainingProject.Name)
        sRes.Append("</project>")
        sRes.Append(System.Environment.NewLine)

        sRes.Append("<date>")
        sRes.Append(DateTime.Now.ToShortDateString())
        sRes.Append("</date>")
        sRes.Append(System.Environment.NewLine)

        sRes.Append("<time>")
        sRes.Append(DateTime.Now.ToLongTimeString())
        sRes.Append("</time>")
        sRes.Append(System.Environment.NewLine)

        sRes.Append("<userid>")
        sRes.Append(Environment.UserName)
        sRes.Append("</userid>")
        sRes.Append(System.Environment.NewLine)
        sRes.Append("<machinename>")
        sRes.Append(Environment.MachineName)
        sRes.Append("</machinename>")
        sRes.Append(System.Environment.NewLine)

        sRes.Append("<name>")
        sRes.Append(GetShortTypeName(poCodeElement.FullName))
        sRes.Append("</name>")
        sRes.Append(System.Environment.NewLine)
        sRes.Append("<fullname>")
        sRes.Append(poCodeElement.FullName)
        sRes.Append("</fullname>")
        sRes.Append(System.Environment.NewLine)

        sDescription = GetDescriptionFromCodeElementsAttributes(poCodeElement)
        If sDescription.Length > 0 Then
            sRes.Append("<curdesc>")
            sRes.Append(sDescription)
            sRes.Append("</curdesc>")
            sRes.Append(System.Environment.NewLine)
        End If

        If poCodeElement.IsCodeType() Then
            sRes.Append("<is-type value=""true""/>")
            sRes.Append(System.Environment.NewLine)
        Else
            sRes.Append("<is-type value=""false""/>")
            sRes.Append(System.Environment.NewLine)
        End If

        sRes.Append("<code-element-type>")
        sRes.Append(sItemType)
        sRes.Append("</code-element-type>")
        sRes.Append(System.Environment.NewLine)

        If poCodeElement.Kind = vsCMElement.vsCMElementFunction Or _
           poCodeElement.Kind = vsCMElement.vsCMElementProperty Or _
           poCodeElement.Kind = vsCMElement.vsCMElementEventsDeclaration Then

            If (poCodeElement.Kind = vsCMElement.vsCMElementFunction) Or (poCodeElement.Kind = vsCMElement.vsCMElementEventsDeclaration) Then
                ' Function or Event
                oFunc = CType(poCodeElement, CodeFunction)
            Else
                ' Property
                oProp = CType(poCodeElement, CodeProperty)
                If Not oProp.Getter Is Nothing Then
                    oFunc = oProp.Getter
                Else
                    oFunc = oProp.Setter
                End If
            End If

            bHasReturn = True

            If poCodeElement.Kind = vsCMElement.vsCMElementFunction Then

                If ((oFunc.FunctionKind And vsCMFunction.vsCMFunctionSub) = vsCMFunction.vsCMFunctionSub) Or _
                   ((oFunc.FunctionKind And vsCMFunction.vsCMFunctionConstructor) = vsCMFunction.vsCMFunctionConstructor) Then
                    bHasReturn = False
                End If
            ElseIf poCodeElement.Kind = vsCMElement.vsCMElementEventsDeclaration Then
                bHasReturn = False
            End If

            If bHasReturn Then
                sRes.Append("<return>")
                sRes.Append(System.Environment.NewLine)

                sRes.Append("<returntypename>")
                sRes.Append(GetShortTypeName(oFunc.Type.AsFullName))
                sRes.Append("</returntypename>")
                sRes.Append("<returntypefullname>")
                sRes.Append(oFunc.Type.AsFullName)
                sRes.Append("</returntypefullname>")

                sRes.Append("</return>")
                sRes.Append(System.Environment.NewLine)

            End If

            oParaList = Utils.GetCodeElementParameters(poCodeElement)
            If Not oParaList Is Nothing Then

                sRes.Append("<arguments>")
                sRes.Append(System.Environment.NewLine)


                For iPos = 0 To oParaList.Length - 1
                    oPara = oParaList(iPos)

                    sRes.Append("<argument>")
                    sRes.Append(System.Environment.NewLine)

                    sRes.Append("<name>")
                    sRes.Append(oPara.Name)
                    sRes.Append("</name>")
                    sRes.Append(System.Environment.NewLine)

                    sRes.Append("<typename>")
                    sRes.Append(GetShortTypeName(oPara.Type.AsFullName()))
                    sRes.Append("</typename>")
                    sRes.Append(System.Environment.NewLine)

                    sRes.Append("<typefullname>")
                    sRes.Append(oPara.Type.AsFullName())
                    sRes.Append("</typefullname>")
                    sRes.Append(System.Environment.NewLine)

                    If Utils.IsVBByRefParameter(oPara) Then
                        sRes.Append("<byref>true</byref>")
                        sRes.Append(System.Environment.NewLine)

                    Else
                        sRes.Append("<byref>false</byref>")
                        sRes.Append(System.Environment.NewLine)

                    End If

                    sRes.Append("</argument>")
                    sRes.Append(System.Environment.NewLine)

                Next

                sRes.Append("</arguments>")
                sRes.Append(System.Environment.NewLine)

            End If

        End If

        sRes.Append("</xmldocinfo>")

        Return sRes.ToString()

    End Function

    Private Shared Function GetShortTypeName(ByVal psLongTypeName As String) As String

        If psLongTypeName.IndexOf("."c) <> -1 Then
            Return psLongTypeName.Substring(psLongTypeName.IndexOf("."c) + 1)
        Else
            Return psLongTypeName
        End If

    End Function

    Private Shared Function GetXMLTransformationForCodeElement(ByVal piTemplateType As TemplateTypesEnum, ByVal poCodeElement As EnvDTE.CodeElement) As String

        Dim sTypeName As String
        Dim sTemplateLocation As String
        Dim bInternalResource As Boolean
        Dim oTransformation As IO.Stream
        Dim oReader As IO.StreamReader
        Dim sTransformation As String

        sTypeName = CodeElement2ItemType(poCodeElement)

        sTemplateLocation = GetItemTypeTransformation(piTemplateType, sTypeName, bInternalResource)

        If bInternalResource Then
            oTransformation = Utils.GetResourceStream(sTemplateLocation)
        Else
            oTransformation = New IO.FileStream(sTemplateLocation, IO.FileMode.Open, IO.FileAccess.Read, IO.FileShare.Read)
        End If

        oReader = New IO.StreamReader(oTransformation)

        sTransformation = oReader.ReadToEnd()

        oTransformation.Close()

        Return sTransformation

    End Function

    Private Shared Function CodeElement2ItemType(ByVal poCodeElement As EnvDTE.CodeElement) As String

        Select Case poCodeElement.Kind
            Case EnvDTE.vsCMElement.vsCMElementClass
                Return "class"
            Case EnvDTE.vsCMElement.vsCMElementDelegate
                Return "delegate"
            Case EnvDTE.vsCMElement.vsCMElementEnum
                Return "enum"
            Case EnvDTE.vsCMElement.vsCMElementFunction
                Return "function"
            Case EnvDTE.vsCMElement.vsCMElementInterface
                Return "interface"
            Case EnvDTE.vsCMElement.vsCMElementNamespace
                Return "namespace"
            Case EnvDTE.vsCMElement.vsCMElementProperty
                Return "property"
            Case EnvDTE.vsCMElement.vsCMElementStruct
                Return "struct"
            Case EnvDTE.vsCMElement.vsCMElementTypeDef
                Return "typedef"
            Case EnvDTE.vsCMElement.vsCMElementVariable
                Return "variable"
            Case EnvDTE.vsCMElement.vsCMElementEventsDeclaration
                Return "eventsdeclaration"
            Case EnvDTE.vsCMElement.vsCMElementEvent
                Return "event"
            Case Else
                Return "default"
        End Select

    End Function

    Public Shared Function GetFilledXMLTemplateForCodeElement(ByVal piTemplateType As TemplateTypesEnum, ByVal poCodeElement As EnvDTE.CodeElement) As String

        Dim sXMLInfo As String
        Dim sXMLTrans As String
        Dim sRes As String

        sXMLInfo = GetXMLInfoForCodeElement(poCodeElement)

        sXMLTrans = GetXMLTransformationForCodeElement(piTemplateType, poCodeElement)

        sRes = Utils.ApplyXSLTransformation(sXMLInfo, sXMLTrans)

        If sRes.Length > 2 Then
            If sRes.Substring(0, 2) = "<?" Then
                If sRes.IndexOf("?>") <> -1 Then
                    sRes = sRes.Substring(sRes.IndexOf("?>") + 2)
                End If
            End If
        End If

        Return sRes

    End Function

End Class
