<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml"/>

<xsl:template match="/xmldocinfo">
<xsl:if test="code-element-type = 'class'">
-----------------------------------------------------------------------------
Project[TAB] : <xsl:value-of select="project" />
Class[TAB] : <xsl:value-of select="name" />
</xsl:if>
<xsl:if test="code-element-type = 'module'">
-----------------------------------------------------------------------------
Project[TAB] : <xsl:value-of select="project" />
Module[TAB] : <xsl:value-of select="name" />
</xsl:if>
<xsl:if test="code-element-type = 'interface'">
-----------------------------------------------------------------------------
Project[TAB] : <xsl:value-of select="project" />
Interface[TAB] : <xsl:value-of select="name" />
</xsl:if>
<xsl:if test="code-element-type = 'struct'">
-----------------------------------------------------------------------------
Project[TAB] : <xsl:value-of select="project" />
Struct[TAB] : <xsl:value-of select="name" />
</xsl:if>

-----------------------------------------------------------------------------
<summary>
[TRICK]<xsl:if test="curdesc"><xsl:value-of select="curdesc" /></xsl:if>[CURSOR]
[TRICK]</summary>
<xsl:if test="count(arguments) > 0">
<xsl:for-each select="arguments/argument">
[TRICK]<param>
<xsl:attribute name="name">
<xsl:value-of select="name" />
</xsl:attribute>
</param>
</xsl:for-each>
</xsl:if>
<xsl:if test="count(return) > 0">
[TRICK]<xsl:choose>
<xsl:when test="code-element-type = 'property'"><value></value></xsl:when>
<xsl:otherwise><returns></returns></xsl:otherwise>
</xsl:choose>
</xsl:if>
[TRICK]<remarks>
[TRICK]</remarks>
[TRICK]<history>
[TRICK][TAB][<xsl:value-of select="userid" />][TAB]<xsl:value-of select="date" />[TAB]Created
[TRICK]</history>
-----------------------------------------------------------------------------
</xsl:template>
</xsl:stylesheet>
