Public Class frmSettings
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Dim myConfig As Configuration

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        myConfig = Configuration.GetInstance()
        Me.chkBuildXML.Checked = myConfig.CreateXMLFiles
        Me.chkHistory.Checked = myConfig.AddHistoryTags
        Me.chkInsertComments.Checked = myConfig.InsertXMLComments

        ' manag list box and text box
        If Me.lstPrefix.Items.IndexOf(myConfig.XMLCommentPrefix) > -1 Then
            Me.lstPrefix.SelectedItem = myConfig.XMLCommentPrefix
        End If
        Me.txtPrefix.Text = myConfig.XMLCommentPrefix

        ' ensure comment is at fromt in case config file edited manually
        If Not txtPrefix.Text.Trim.StartsWith("'") Then
            MsgBox("Prefix for XML Comment Block must begin with an single quote (').")
            txtPrefix.Focus()
        End If

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents chkBuildXML As System.Windows.Forms.CheckBox
    Friend WithEvents lstPrefix As System.Windows.Forms.ComboBox
    Friend WithEvents btnOk As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents chkHistory As System.Windows.Forms.CheckBox
    Friend WithEvents chkInsertComments As System.Windows.Forms.CheckBox
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents txtPrefix As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.chkBuildXML = New System.Windows.Forms.CheckBox
        Me.lstPrefix = New System.Windows.Forms.ComboBox
        Me.chkInsertComments = New System.Windows.Forms.CheckBox
        Me.btnOk = New System.Windows.Forms.Button
        Me.btnCancel = New System.Windows.Forms.Button
        Me.chkHistory = New System.Windows.Forms.CheckBox
        Me.txtPrefix = New System.Windows.Forms.TextBox
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.GroupBox1.SuspendLayout()
        Me.SuspendLayout()
        '
        'chkBuildXML
        '
        Me.chkBuildXML.Checked = True
        Me.chkBuildXML.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkBuildXML.Location = New System.Drawing.Point(16, 8)
        Me.chkBuildXML.Name = "chkBuildXML"
        Me.chkBuildXML.Size = New System.Drawing.Size(136, 32)
        Me.chkBuildXML.TabIndex = 0
        Me.chkBuildXML.Text = "Create .xml files when projects are built"
        '
        'lstPrefix
        '
        Me.lstPrefix.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.lstPrefix.Items.AddRange(New Object() {"'''", "'", "'@", "'//"})
        Me.lstPrefix.Location = New System.Drawing.Point(8, 40)
        Me.lstPrefix.Name = "lstPrefix"
        Me.lstPrefix.Size = New System.Drawing.Size(121, 21)
        Me.lstPrefix.TabIndex = 1
        '
        'chkInsertComments
        '
        Me.chkInsertComments.Checked = True
        Me.chkInsertComments.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkInsertComments.Location = New System.Drawing.Point(16, 48)
        Me.chkInsertComments.Name = "chkInsertComments"
        Me.chkInsertComments.Size = New System.Drawing.Size(128, 32)
        Me.chkInsertComments.TabIndex = 3
        Me.chkInsertComments.Text = "Insert XML comments in source code"
        '
        'btnOk
        '
        Me.btnOk.AccessibleName = "Ok"
        Me.btnOk.AccessibleRole = System.Windows.Forms.AccessibleRole.PushButton
        Me.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.btnOk.Location = New System.Drawing.Point(176, 8)
        Me.btnOk.Name = "btnOk"
        Me.btnOk.TabIndex = 4
        Me.btnOk.Text = "Ok"
        '
        'btnCancel
        '
        Me.btnCancel.AccessibleName = "Cancel"
        Me.btnCancel.AccessibleRole = System.Windows.Forms.AccessibleRole.PushButton
        Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancel.Location = New System.Drawing.Point(176, 40)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.TabIndex = 5
        Me.btnCancel.Text = "Cancel"
        '
        'chkHistory
        '
        Me.chkHistory.Location = New System.Drawing.Point(16, 88)
        Me.chkHistory.Name = "chkHistory"
        Me.chkHistory.Size = New System.Drawing.Size(120, 24)
        Me.chkHistory.TabIndex = 6
        Me.chkHistory.Text = "Add <history> tags"
        Me.chkHistory.Visible = False
        '
        'txtPrefix
        '
        Me.txtPrefix.Location = New System.Drawing.Point(8, 88)
        Me.txtPrefix.MaxLength = 5
        Me.txtPrefix.Name = "txtPrefix"
        Me.txtPrefix.Size = New System.Drawing.Size(120, 20)
        Me.txtPrefix.TabIndex = 7
        Me.txtPrefix.Text = ""
        '
        'GroupBox1
        '
        Me.GroupBox1.Controls.Add(Me.txtPrefix)
        Me.GroupBox1.Controls.Add(Me.Label2)
        Me.GroupBox1.Controls.Add(Me.lstPrefix)
        Me.GroupBox1.Controls.Add(Me.Label1)
        Me.GroupBox1.Location = New System.Drawing.Point(16, 128)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(144, 128)
        Me.GroupBox1.TabIndex = 8
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Comment Prefix"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(8, 72)
        Me.Label2.Name = "Label2"
        Me.Label2.TabIndex = 9
        Me.Label2.Text = "Custom"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 24)
        Me.Label1.Name = "Label1"
        Me.Label1.TabIndex = 8
        Me.Label1.Text = "Pre-select"
        '
        'frmSettings
        '
        Me.AcceptButton = Me.btnOk
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnCancel
        Me.ClientSize = New System.Drawing.Size(266, 271)
        Me.Controls.Add(Me.GroupBox1)
        Me.Controls.Add(Me.chkHistory)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOk)
        Me.Controls.Add(Me.chkInsertComments)
        Me.Controls.Add(Me.chkBuildXML)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.ImeMode = System.Windows.Forms.ImeMode.Off
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "frmSettings"
        Me.Text = "VBCommenter Settings"
        Me.TopMost = True
        Me.GroupBox1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        myConfig.CreateXMLFiles = Me.chkBuildXML.Checked
        myConfig.AddHistoryTags = Me.chkHistory.Checked
        myConfig.InsertXMLComments = Me.chkInsertComments.Checked
        myConfig.XMLCommentPrefix = Me.txtPrefix.Text.Trim
    End Sub

    'Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
    '    Me.Close()
    'End Sub

    Private Sub lstPrefix_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstPrefix.SelectedIndexChanged
        ' change text to match new selection
        If Me.lstPrefix.SelectedIndex <> -1 Then
            txtPrefix.Text = lstPrefix.Text
        End If

    End Sub

    Private Sub txtPrefix_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtPrefix.LostFocus

        ' trim text
        txtPrefix.Text = txtPrefix.Text.Trim

        ' keep drop down and text box in sync if possible
        If Me.lstPrefix.Items.IndexOf(txtPrefix.Text) > -1 Then
            Me.lstPrefix.SelectedItem = txtPrefix.Text
        Else
            Me.lstPrefix.SelectedIndex = -1
        End If

    End Sub

    Private Sub frmSettings_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ' do not allow close if no ' at start
        If Me.DialogResult = Windows.Forms.DialogResult.OK Then
            If Not txtPrefix.Text.Trim.StartsWith("'") Then
                MsgBox("Prefix for XML Comment Block must begin with an single quote (').")
                txtPrefix.Focus()
                e.Cancel = True
            End If
        End If

    End Sub
End Class
